import boto3
import json
import os
from io import StringIO, BytesIO
import pandas as pd
import numpy as np
from vaderSentiment import vaderSentiment as vs
import urllib
from urllib.parse import urlparse


sa = vs.SentimentIntensityAnalyzer()

# s3 = boto3.client('s3')
# # sqs = boto3.client('sqs')
# # #define global variable
# # queue_url = 'https://sqs.us-east-1.amazonaws.com/635413725004/lambda-split-sqs'



# def lambda_handler(event, context):
    
#     #1 - Get the bucket name
#     bucket = event['Records'][0]['s3']['bucket']['name']
    
    

#     #2 - Get the file/key name
#     key = urllib.parse.unquote_plus(event['Records'][0]['s3']['object']['key'])
    

#     #3 - Fetch the file from S3
#     response = s3.get_object(Bucket=bucket, Key=key)

#     #4 - Deserialize the file's content
#     file_content = response["Body"].read().decode('utf-8')
    
#     df = pd.read_csv(StringIO(file_content))
#     # print(df.head(5))
    
#     df.text = df.text.fillna('')
#     # print(bucket)
#     # print(key)
#     full_path=key
#     trim_path=os.path.relpath(full_path, 'raw')
#     file_name_trunk = trim_path.split(".")[0]
#     split_files_name_trunk = file_name_trunk
#     output_file = f"{split_files_name_trunk}.parquet"
#     # print(trim_path)
#     df["compound"] = ""
#     df["pos"] = ""
#     df["neu"] = ""
#     df["neg"] = ""    
    
#     # for i in range(0, len(df.index)):
#     df['compound'] = df['text'].apply(lambda x: sa.polarity_scores(x)['compound'])
#     df['pos'] = df['text'].apply(lambda x: sa.polarity_scores(x)['pos'])
#     df['neu'] = df['text'].apply(lambda x: sa.polarity_scores(x)['neu'])
#     df['neg'] = df['text'].apply(lambda x: sa.polarity_scores(x)['neg'])
    
    

#     # df['hashtags']=df['hashtags'].replace('Nan', '[]')
#     df['hashtags']=df['hashtags'].replace(np.NaN, '[]', inplace=False)

#     # print(df['hashtags'].head(10))
#     df['hashtags']=df['hashtags'].astype(str)
#     df['hashtags'] = df['hashtags'].apply(lambda ele: eval(ele))
#     print(type(df['hashtags'][0]))
#     # print(df['hashtags'][0])
#     # print(df.head(1))    
#     # csv_buffer = BytesIO()
#     # df.to_parquet(csv_buffer, index=False)
#     # content = csv_buffer.getvalue()
#     # s3.put_object(Bucket=bucket, Key='processedv3/'+output_file, Body=content)

s3 = boto3.client('s3')
sqs = boto3.client('sqs')
#define global variable
queue_url = 'https://sqs.us-east-1.amazonaws.com/635413725004/lambda-split-sqs'



def lambda_handler(event, context):
    # print(event)
    # receipt_handle = response['Messages'][0]['receiptHandle']
    print(event)
    bucket = event['Records'][0]['body']
    key = event['Records'][0]['messageAttributes']['key']['stringValue']

# #     print(event)
    
# #     #1 - Get the bucket name
# #     bucket = event['Records'][0]['s3']['bucket']['name']
    
    

# #     #2 - Get the file/key name
# #     key = urllib.parse.unquote_plus(event['Records'][0]['s3']['object']['key'])
    

    #3 - Fetch the file from S3
    response = s3.get_object(Bucket=bucket, Key=key)

    #4 - Deserialize the file's content
    file_content = response["Body"].read().decode('utf-8')
    
    df = pd.read_csv(StringIO(file_content))
    # print(df.head(5))
    
    df.text = df.text.fillna('')
    
    
    def is_url(url):
      try:
        result = urlparse(url)
        return all([result.scheme, result.netloc])
      except ValueError:
        return False
    
    df['text'] = [' '.join(y for y in x.split() if not is_url(y)) for x in df['text']]
    
    
    
    # print(bucket)
    # print(key)
    full_path=key
    trim_path=os.path.relpath(full_path, 'raw')
    
    file_name_trunk = trim_path.split(".")[0]
    split_files_name_trunk = file_name_trunk
    output_file = f"{split_files_name_trunk}/covid19_processed.parquet"
    
    df["compound"] = ""
    df["pos"] = ""
    df["neu"] = ""
    df["neg"] = ""    
    
    # for i in range(0, len(df.index)):
    df['compound'] = df['text'].apply(lambda x: sa.polarity_scores(x)['compound'])
    df['pos'] = df['text'].apply(lambda x: sa.polarity_scores(x)['pos'])
    df['neu'] = df['text'].apply(lambda x: sa.polarity_scores(x)['neu'])
    df['neg'] = df['text'].apply(lambda x: sa.polarity_scores(x)['neg'])
    
    df['hashtags']=df['hashtags'].replace(np.NaN, '[]', inplace=False)

    df['hashtags']=df['hashtags'].astype(str)
    df['hashtags'] = df['hashtags'].apply(lambda ele: eval(ele))
    
    # df=df.drop(columns=['user_followers', 'user_friends', 'user_favourites'])
    # cols_to_drop = ['user_followers', 'user_friends', 'user_favourites']
    # df = df[df.columns.drop(cols_to_drop)]
    # df.drop(columns=['user_followers', 'user_friends', 'user_favourites'], axis=1, inplace=True)
    df['user_followers'] = df['user_followers'].astype(int)
    df['user_friends'] = df['user_friends'].astype(int)
    df['user_favourites'] = df['user_favourites'].astype(int)
    df['compound'] = df['compound'].astype(float)
    df['pos'] = df['pos'].astype(float)
    df['neu'] = df['neu'].astype(float)
    df['neg'] = df['neg'].astype(float)
    
    
    print(df.head(10))    
    csv_buffer = BytesIO()
    # df.to_csv(csv_buffer, index=False)
    df.to_parquet(csv_buffer, index=False)
    content = csv_buffer.getvalue()
    # s3.put_object(Bucket=bucket, Key='processed/'+trim_path, Body=content)
    s3.put_object(Bucket=bucket, Key='processedv4/'+output_file, Body=content)